#include "HelloWorldScene.h"

CCScene* HelloWorld::scene()
{
	CCScene *scene = CCScene::node();
	HelloWorld *layer = HelloWorld::node();
	scene->addChild(layer);
	return scene;
}

/*	ʱȭ ϴ Լ	*/
bool HelloWorld::init()
{
	if ( !CCLayer::init() )		
		return false;
	
	m_bComTouched = false;					//	false ؼ,  ĥ غ
	m_fCom_Time = 0.3f;						//	 ð
	m_fDelay = 0.f;							//	ð  
	
	//	 ȭ â ũ⸦ ´.
	CCSize size = CCDirector::sharedDirector()->getWinSize();
	
	//	忡   
	m_pBG = new CCSprite;
	m_pBG->initWithFile("court.png");
	m_pBG->setAnchorPoint(ccp(0, 0));
	m_pBG->setPosition(ccp(0 ,0));
	m_pBG->setScale(0.333f);
	this->addChild(m_pBG);

	m_fCom_Speed = 800.f;					//	ǻ ̵ ӵ
	m_fPlayer_Speed = MAX_SPEED - 100;		//	÷̾ ̵ ӵ
	m_fPuck_Speed = MAX_SPEED;				//	 ̵ ӵ
	m_Puck_Vec = ccp(0, 0);					//	 ̵  
	m_Com_Vec = ccp(0, 0);					//	ǻ ̵  
	
	m_Court_Range = m_pBG->boundingBox();	//	 ũ 

	const float l_offSetY = 250;			//	 ߾ӿ y   

	m_pPlayer = new CCSprite;
	m_pPlayer->initWithFile("mallet.png");
	//	÷̾ ġ ȭ ߾ Ʒʿ ġ
	m_pPlayer->setPosition(ccp(size.width / 2, size.height / 2 - l_offSetY ) );
	m_pPlayer->setScale(0.25f);
	this->addChild(m_pPlayer);

	m_pComputer = new CCSprite;
	m_pComputer->initWithFile("mallet.png");
	//	ǻ ġ ȭ ߾ ʿ ġ
	m_pComputer->setPosition(ccp(size.width / 2, size.height / 2 + l_offSetY) );
	m_pComputer->setScale(0.25f);
	this->addChild(m_pComputer);
	
	//	 ó   ǻ ġ , ߿ ǻ   ϴµ ʿ
	m_Com_Orign_pos = m_pComputer->getPosition();

	m_pPuck = new CCSprite;
	m_pPuck->initWithFile("puck.png");
	//	 ġ ȭ ߾ӿ ġ
	m_pPuck->setPosition(ccp(size.width / 2, size.height / 2 ));
	m_pPuck->setScale(0.25f);
	this->addChild(m_pPuck);

	this->schedule(schedule_selector(HelloWorld::Update));

	return true;
}

/*	ֱ Ǵ Լ	*/
void HelloWorld::Update(float dt)
{
	this->PlayerAction(dt);	//	÷̾ ̵
	
	this->ComAction(dt);	//	ǻ ̵

	this->PuckAction(dt);	//	 ̵

	this->SetPuckVector(m_pPlayer);		//	 ÷̾ 浹 üũ
	
	this->SetPuckVector(m_pComputer);	//	 ǻ 浹 üũ

	this->BlockPuck();					//	  浹 üũ
}

/*	 Ű Է¿  ÷̾ ̵ Ű Լ	*/
void HelloWorld::PlayerAction(float dt)
{
	CCPoint pos = m_pPlayer->getPosition();
	
	m_Player_Vec.x = 0;
	m_Player_Vec.y = 0;

	if( GetAsyncKeyState( VK_LEFT ) )
	{
		m_Player_Vec.x = -1;
		//pos.x -=  m_fPlayer_Speed * dt;
	}
	if( GetAsyncKeyState( VK_DOWN ) )
	{
		m_Player_Vec.y = -1;
		//pos.y -= m_fPlayer_Speed * dt;
	}
	if( GetAsyncKeyState( VK_RIGHT ) )
	{
		m_Player_Vec.x = 1;
		//pos.x += m_fPlayer_Speed * dt;
	}
	if( GetAsyncKeyState( VK_UP ) )
	{
		m_Player_Vec.y = 1;
		//pos.y += m_fPlayer_Speed * dt;
	}

	pos.x += m_fPlayer_Speed * m_Player_Vec.x * dt;
	pos.y += m_fPlayer_Speed * m_Player_Vec.y * dt;

	m_pPlayer->setPosition(pos);

	/*
		÷̾   ִ  ߾Ӽ  Ʒ ,
			xδ 0     ̰
			yδ 0     ̴.
	*/
	this->BlockObject(	m_pPlayer, 
						CCRect::CCRectGetMaxY(m_Court_Range) / 2, 
						0 );
}

/*	ǻ͸ ̵ Ű Լ	*/
void HelloWorld::ComAction(float dt)
{
	CCPoint pos = m_pComputer->getPosition();

	pos.x += m_Com_Vec.x * m_fCom_Speed * dt;
	pos.y += m_Com_Vec.y * m_fCom_Speed * dt;

	m_pComputer->setPosition(pos);

	/*
		ǻͰ   ִ  ߾Ӽ   ,
			xδ 0     ̰
			yδ          ̴.
	*/
	this->BlockObject(	m_pComputer, 
						CCRect::CCRectGetMaxY(m_Court_Range), 
						CCRect::CCRectGetMaxY(m_Court_Range) / 2 
						);
}

/*	 ̵ Ű Լ	*/
void HelloWorld::PuckAction(float dt)
{
	CCPoint pos = m_pPuck->getPosition();

	pos.x += m_Puck_Vec.x * m_fPuck_Speed * dt;
	pos.y += m_Puck_Vec.y * m_fPuck_Speed * dt;

	m_pPuck->setPosition(pos);
}

/*	
	÷̾ ǻͰ ڱ   ʰ ִ Լ
	Ű  Ʈ 忡   ִ y ̵ ̴.
*/
void HelloWorld::BlockObject(CCSprite* _pObj,float Top,float Bottom)
{
	//	÷̾ Ȥ ǻ  ġ ´.
	CCPoint pos = _pObj->getPosition();
	
	//	÷̾ Ȥ ǻ  ( ũ ġ ) ´.
	CCRect temp = _pObj->boundingBox();
	
	/*
		l_RacketMaxX  l_RacketMinX ,
		÷̾ Ȥ ǻ   Ѵ.
	*/ 
	float l_RacketMaxX = CCRect::CCRectGetMaxX( temp );
	float l_RacketMinX = CCRect::CCRectGetMinX( temp );

	//	÷̾ Ȥ ǻ   Ѵ.
	float Radius = ( l_RacketMaxX - l_RacketMinX ) / 2;
	
	/*
		Ʒ  , ǻ Ȥ ÷̾  
		ڱ ڽŵ   ϰ  κ̴.
	*/
	float ScreenLeft = CCRect::CCRectGetMinX( m_Court_Range ) + Radius;
	float ScreenRight = CCRect::CCRectGetMaxX( m_Court_Range ) - Radius;
	float ScreenTop = Top - Radius;
	float ScreenBottom = Bottom + Radius;
	
	if(ScreenLeft > pos.x )		pos.x = ScreenLeft;
	if(ScreenRight < pos.x )	pos.x = ScreenRight;
	if(ScreenTop < pos.y)		pos.y = ScreenTop;
	if(ScreenBottom > pos.y)	pos.y = ScreenBottom;
	
	_pObj->setPosition(pos);
}

/*
	 (÷̾ Ȥ ǻ) 浹 üũؼ
	浹 ߻ϸ  ̵  ͸ ϴ Լ
*/
void HelloWorld::SetPuckVector(CCSprite* _pObj)
{
	CCPoint racketPos = _pObj->getPosition();
	CCPoint puckPos = m_pPuck->getPosition();

	CCRect temp = _pObj->boundingBox();
	
	//	(÷̾ Ȥ ǻ)   .
	float rackRadius = ( CCRect::CCRectGetMaxX(temp) - CCRect::CCRectGetMinX(temp) ) / 2;	
	
	CCRect temp2 = m_pPuck->boundingBox();
	
	//	    .
	float puckRadius = ( CCRect::CCRectGetMaxX(temp2) - CCRect::CCRectGetMinX(temp2) ) / 2;
	
	//	   ̿ؼ 浹üũ
	float fDistance = sqrtf(	(racketPos.x - puckPos.x) * (racketPos.x - puckPos.x) + 
								(racketPos.y - puckPos.y) * (racketPos.y - puckPos.y) 
								);
	
	//	  浹,  ̵  ͸ 
	if( fDistance <= rackRadius + puckRadius )
	{
		m_Puck_Vec.x = puckPos.x - racketPos.x;
		m_Puck_Vec.y = puckPos.y - racketPos.y;
		
		//	̵  ͸  ȭ
		m_Puck_Vec.x /= fDistance;
		m_Puck_Vec.y /= fDistance;
		
		float dot;					//	  ϱ  .

		float RacketVecManitude;	//	 ̵   ũ
		float cosineTheta;			//	  cosine Ÿ  
		/*
			 ǻͿ ÷̾ 2̴ϱ,
			  浹 ߴµ, 	 ÷̾ ϰ 浹ߴ
			 ǻ ϰ 浹ߴ ,  ̵͸ ó .
		*/	
		
		//	ǻ  
		if( _pObj == m_pComputer && !m_bComTouched )	
		{	
			RacketVecManitude = sqrtf(	m_Com_Vec.x * m_Com_Vec.x + 
										m_Com_Vec.y * m_Com_Vec.y );
			
			//	ǻ  ̵   ũⰡ 0 쿡   ó
			if ( RacketVecManitude == 0.f )
			{
				RacketVecManitude = 1.f;
			}

			m_bComTouched = true;

			dot = m_Puck_Vec.x * m_Com_Vec.x + m_Puck_Vec.y * m_Com_Vec.y;

			cosineTheta = dot / RacketVecManitude;

			m_fPuck_Speed = MAX_SPEED * fabs(cosineTheta) + 300.f;
		}
		//	÷̾  
		else
		{
			RacketVecManitude = sqrtf(	m_Player_Vec.x * m_Player_Vec.x + 
										m_Player_Vec.y * m_Player_Vec.y );
			
			//	÷̾  ̵   ũⰡ 0 쿡   ó
			if ( RacketVecManitude == 0.f )
			{
				RacketVecManitude = 1.f;
			}

			dot = m_Puck_Vec.x * m_Player_Vec.x + m_Puck_Vec.y * m_Player_Vec.y;

			cosineTheta = dot / RacketVecManitude;

			m_fPuck_Speed = MAX_SPEED * fabs(cosineTheta) + 300.f;
		}
	}
}

/*
	   浹 üũ Ȯؼ,    
	ݻ纤͸ ̿ؼ  ̵  缳 Ѵ.
*/
void HelloWorld::BlockPuck()
{
	//	 ( ũ ġ ) ´.
	CCRect temp = m_pPuck->boundingBox();
	
	CCPoint pos = m_pPuck->getPosition();
	
	//	l_PuckMaxX  l_PuckMinX ,   Ѵ.
	float l_PuckMaxX = CCRect::CCRectGetMaxX( temp );
	float l_PuckMinX = CCRect::CCRectGetMinX( temp );

	//	  Ѵ.
	float Radius = ( l_PuckMaxX - l_PuckMinX ) / 2;
	
	float ScreenLeft = Radius;
	float ScreenRight = CCRect::CCRectGetMaxX(m_Court_Range) - Radius;
	float ScreenTop = CCRect::CCRectGetMaxY(m_Court_Range) - Radius;
	float ScreenBottom = Radius;
	
	/*
		Ʒ 4 if ݻ纤͸ ϴ .
	*/
	if(ScreenLeft > pos.x )		m_Puck_Vec.x *= -1;
	if(ScreenRight < pos.x )	m_Puck_Vec.x *= -1;
	if(ScreenTop < pos.y)		m_Puck_Vec.y *= -1;
	if(ScreenBottom > pos.y)	m_Puck_Vec.y *= -1;
	
	
	//	Ʒ  ,    ϰ  κ̴.
	if(ScreenLeft > pos.x )		pos.x = ScreenLeft;
	if(ScreenRight < pos.x )	pos.x = ScreenRight;
	if(ScreenTop < pos.y)		pos.y = ScreenTop;
	if(ScreenBottom > pos.y)	pos.y = ScreenBottom;

	m_pPuck->setPosition(pos);
}